<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Procedure Nodes</TITLE>
<link href="suif1_20.html" rel=Next>
<link href="suif1_18.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_18.html">previous</A>, <A HREF="suif1_20.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC19" HREF="suif1_toc.html#TOC19">Procedure Nodes</A></H3>
<P>
<A NAME="IDX114"></A>
<A NAME="IDX115"></A>

</P>
<P>
<A NAME="IDX116"></A>
A special kind of block node is used as the root of each AST.  These
<CODE>tree_proc</CODE> nodes are derived from the <CODE>tree_block</CODE> class.
They are essentially the same as other block nodes, but they include a
few extra methods and have a slightly different kind of symbol table.
SUIF does not support nested procedures, so <CODE>tree_proc</CODE> nodes may
only be used at the roots of ASTs.

</P>
<P>
<A NAME="IDX117"></A>
A procedure node's symbol table must be a <CODE>proc_symtab</CODE> instead of
just an ordinary <CODE>block_symtab</CODE>.  The <CODE>proc_syms</CODE> method is
provided to cast the symbol table pointer to be a <CODE>proc_symtab</CODE>.  A
<CODE>tree_proc</CODE> node also has a pointer to the symbol of the
corresponding procedure.  This pointer is set automatically when a
<CODE>tree_proc</CODE> is attached to the procedure symbol.  For any tree node
in an AST, the <CODE>proc</CODE> method retrieves this procedure symbol from
the <CODE>tree_proc</CODE> at the root of the tree.

</P>
<P>
Because <CODE>tree_proc</CODE> nodes are always at the roots of the ASTs,
their <CODE>parent</CODE> list pointers (see section <A HREF="suif1_13.html#SEC13">Other Features Shared by All Tree Nodes</A>) are
always <CODE>NULL</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_18.html">previous</A>, <A HREF="suif1_20.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
